﻿using System;
using System.Net;
using System.Windows;
using System.Windows.Controls;
using System.Windows.Documents;
using System.Windows.Ink;
using System.Windows.Input;
using System.Windows.Media;
using System.Windows.Media.Animation;
using System.Windows.Shapes;
using System.Threading;

namespace CS185_HW2
{
    /// <summary>
    /// This class forces focus to set on the specified UIElement 
    /// </summary>
    public class FocusHelper
    {

        /// <summary>
        /// Set focus to UIElement
        /// </summary>
        /// <param name="element">The element to set focus on</param>

        public static void Focus(Control element)
        {
            //Focus in a callback to run on another thread, ensuring the main 
            //UI thread is initialized by the time focus is set
            ThreadPool.QueueUserWorkItem(delegate(Object theElement)
            {
                
                 Control elem = (Control)theElement;
                
                elem.Dispatcher.BeginInvoke(
                    (Action)delegate()
                    {
                        elem.Focus();
                        
                    });
            }, element);
        }
    }

}
